
//
// Academic License - for use in teaching, academic research, and meeting
// course requirements at degree granting institutions only.  Not for
// government, commercial, or other organizational use.
// File: kin_xyzbc_tt_J2P_jt.cpp
//
// MATLAB Coder version            : 5.4
//

// Include Files
#include "kin_xyzbc_tt_J2P_jt.h"
#include "coder_array.h"
#include <cmath>

// Function Definitions
//
// function J2P_jt = kin_xyzbc_tt_J2P_jt(in1,in2,in3,in4)
//
// kin_xyzbc_tt_J2P_jt
//     J2P_jt = kin_xyzbc_tt_J2P_jt(IN1,IN2,IN3,IN4)
//
// Arguments    : const ::coder::array<double, 1U> &in1
//                const ::coder::array<double, 1U> &in2
//                const ::coder::array<double, 1U> &in3
//                const ::coder::array<double, 1U> &in4
//                double J2P_jt[5][5]
// Return Type  : void
//
namespace ocn {
void kin_xyzbc_tt_J2P_jt(const ::coder::array<double, 1U> &in1,
                         const ::coder::array<double, 1U> &in2,
                         const ::coder::array<double, 1U> &in3,
                         const ::coder::array<double, 1U> &in4, double J2P_jt[5][5])
{
    double b_t2[25];
    double ab_t2_tmp;
    double ac_t2_tmp;
    double b_t2_tmp;
    double b_t2_tmp_tmp;
    double bb_t2_tmp;
    double bc_t2_tmp;
    double c_t2_tmp;
    double c_t2_tmp_tmp;
    double cb_t2_tmp;
    double cc_t2_tmp;
    double d_t2_tmp;
    double d_t2_tmp_tmp;
    double db_t2_tmp;
    double dc_t2_tmp;
    double e_t2_tmp;
    double eb_t2_tmp;
    double ec_t2_tmp;
    double f_t2_tmp;
    double fb_t2_tmp;
    double fc_t2_tmp;
    double g_t2_tmp;
    double gb_t2_tmp;
    double gc_t2_tmp;
    double h_t2_tmp;
    double hb_t2_tmp;
    double hc_t2_tmp;
    double i_t2_tmp;
    double ib_t2_tmp;
    double ic_t2_tmp;
    double j_t2_tmp;
    double jb_t2_tmp;
    double jc_t2_tmp;
    double k_t2_tmp;
    double kb_t2_tmp;
    double kc_t2_tmp;
    double l_t2_tmp;
    double lb_t2_tmp;
    double lc_t2_tmp;
    double m_t2_tmp;
    double mb_t2_tmp;
    double mc_t2_tmp;
    double n_t2_tmp;
    double nb_t2_tmp;
    double nc_t2_tmp;
    double o_t2_tmp;
    double ob_t2_tmp;
    double oc_t2_tmp;
    double p_t2_tmp;
    double pb_t2_tmp;
    double q_t2_tmp;
    double qb_t2_tmp;
    double r_t2_tmp;
    double rb_t2_tmp;
    double s_t2_tmp;
    double sb_t2_tmp;
    double t2;
    double t2_tmp;
    double t2_tmp_tmp;
    double t3;
    double t4;
    double t5;
    double t6;
    double t7;
    double t_t2_tmp;
    double tb_t2_tmp;
    double u_t2_tmp;
    double ub_t2_tmp;
    double v_t2_tmp;
    double vb_t2_tmp;
    double w_t2_tmp;
    double wb_t2_tmp;
    double x_t2_tmp;
    double xb_t2_tmp;
    double y_t2_tmp;
    double yb_t2_tmp;
    //     This function was generated by the Symbolic Math Toolbox version 9.1.
    //     07-Nov-2023 14:54:38
    // Jacobian second derivative ( Inverse Kinematics ) :
    // INPUTS :
    // 	r_t    (5x1) : pose vector ( piece frame )
    // 	v_t    (5x1) : speed vector ( piece frame )
    // 	a_t    (5x1) : acceleration vector( piece frame )
    // 	j_t    (5x1) : jerk vector( piece frame )
    // 	p      (3x5) : parameters
    // OUTPUTS :
    // 	M      (5x5) : resulting matrix
    // 'kin_xyzbc_tt_J2P_jt:18' b = in1(4,:);
    // 'kin_xyzbc_tt_J2P_jt:19' c = in1(5,:);
    // 'kin_xyzbc_tt_J2P_jt:20' offB1 = in4(10);
    // 'kin_xyzbc_tt_J2P_jt:21' offC1 = in4(13);
    // 'kin_xyzbc_tt_J2P_jt:22' offB3 = in4(12);
    // 'kin_xyzbc_tt_J2P_jt:23' offC2 = in4(14);
    // 'kin_xyzbc_tt_J2P_jt:24' offC3 = in4(15);
    // 'kin_xyzbc_tt_J2P_jt:25' offP1 = in4(7);
    // 'kin_xyzbc_tt_J2P_jt:26' offP2 = in4(8);
    // 'kin_xyzbc_tt_J2P_jt:27' offP3 = in4(9);
    // 'kin_xyzbc_tt_J2P_jt:28' tp1 = in2(1,:);
    // 'kin_xyzbc_tt_J2P_jt:29' tp2 = in2(2,:);
    // 'kin_xyzbc_tt_J2P_jt:30' tp3 = in2(3,:);
    // 'kin_xyzbc_tt_J2P_jt:31' tp4 = in2(4,:);
    // 'kin_xyzbc_tt_J2P_jt:32' tp5 = in2(5,:);
    // 'kin_xyzbc_tt_J2P_jt:33' tpp1 = in3(1,:);
    // 'kin_xyzbc_tt_J2P_jt:34' tpp2 = in3(2,:);
    // 'kin_xyzbc_tt_J2P_jt:35' tpp3 = in3(3,:);
    // 'kin_xyzbc_tt_J2P_jt:36' tpp4 = in3(4,:);
    // 'kin_xyzbc_tt_J2P_jt:37' tpp5 = in3(5,:);
    // 'kin_xyzbc_tt_J2P_jt:38' x = in1(1,:);
    // 'kin_xyzbc_tt_J2P_jt:39' y = in1(2,:);
    // 'kin_xyzbc_tt_J2P_jt:40' z = in1(3,:);
    // 'kin_xyzbc_tt_J2P_jt:41' t2 = cos(b);
    t2 = std::cos(in1[3]);
    // 'kin_xyzbc_tt_J2P_jt:42' t3 = cos(c);
    t3 = std::cos(in1[4]);
    // 'kin_xyzbc_tt_J2P_jt:43' t4 = sin(b);
    t4 = std::sin(in1[3]);
    // 'kin_xyzbc_tt_J2P_jt:44' t5 = sin(c);
    t5 = std::sin(in1[4]);
    // 'kin_xyzbc_tt_J2P_jt:45' t6 = tp4.^2;
    t6 = in2[3] * in2[3];
    // 'kin_xyzbc_tt_J2P_jt:46' t7 = tp5.^2;
    t7 = in2[4] * in2[4];
    // 'kin_xyzbc_tt_J2P_jt:47' et1 =
    // t2.*tpp3+offB1.*t4.*t6-offB3.*t2.*t6-offC3.*t2.*t6-offP3.*t2.*t6-offB1.*t2.*tpp4-offB3.*t4.*tpp4-offC3.*t4.*tpp4-offP3.*t4.*tpp4-t3.*t4.*tpp1+t4.*t5.*tpp2-t4.*tp3.*tp4.*2.0-t2.*t6.*z-t4.*tpp4.*z+offC1.*t3.*t4.*t6+offC1.*t3.*t4.*t7-offC2.*t4.*t5.*t6-offC2.*t4.*t5.*t7+offP1.*t3.*t4.*t6+offP1.*t3.*t4.*t7-offP2.*t4.*t5.*t6-offP2.*t4.*t5.*t7-offC1.*t2.*t3.*tpp4+offC2.*t2.*t5.*tpp4+offC2.*t3.*t4.*tpp5+offC1.*t4.*t5.*tpp5-offP1.*t2.*t3.*tpp4+offP2.*t2.*t5.*tpp4+offP2.*t3.*t4.*tpp5+offP1.*t4.*t5.*tpp5-t2.*t3.*tp1.*tp4.*2.0+t2.*t5.*tp2.*tp4.*2.0+t3.*t4.*tp2.*tp5.*2.0+t4.*t5.*tp1.*tp5.*2.0+t3.*t4.*t6.*x;
    // 'kin_xyzbc_tt_J2P_jt:48' et2 =
    // t3.*t4.*t7.*x-t2.*t3.*tpp4.*x+t4.*t5.*tpp5.*x-t4.*t5.*t6.*y-t4.*t5.*t7.*y+t2.*t5.*tpp4.*y+t3.*t4.*tpp5.*y+offC2.*t2.*t3.*tp4.*tp5.*2.0+offC1.*t2.*t5.*tp4.*tp5.*2.0+offP2.*t2.*t3.*tp4.*tp5.*2.0+offP1.*t2.*t5.*tp4.*tp5.*2.0+t2.*t5.*tp4.*tp5.*x.*2.0+t2.*t3.*tp4.*tp5.*y.*2.0;
    // 'kin_xyzbc_tt_J2P_jt:49' et3 =
    // -t2.*t3.*tpp2-t2.*t5.*tpp1+offC2.*t2.*t3.*t6+offC1.*t2.*t5.*t6+offC2.*t2.*t3.*t7+offC1.*t2.*t5.*t7+offP2.*t2.*t3.*t6+offP1.*t2.*t5.*t6+offP2.*t2.*t3.*t7+offP1.*t2.*t5.*t7-offC1.*t2.*t3.*tpp5+offC2.*t3.*t4.*tpp4+offC1.*t4.*t5.*tpp4+offC2.*t2.*t5.*tpp5-offP1.*t2.*t3.*tpp5+offP2.*t3.*t4.*tpp4+offP1.*t4.*t5.*tpp4+offP2.*t2.*t5.*tpp5-t2.*t3.*tp1.*tp5.*2.0+t3.*t4.*tp2.*tp4.*2.0+t2.*t5.*tp2.*tp5.*2.0+t4.*t5.*tp1.*tp4.*2.0+t2.*t5.*t6.*x+t2.*t5.*t7.*x-t2.*t3.*tpp5.*x+t4.*t5.*tpp4.*x+t2.*t3.*t6.*y+t2.*t3.*t7.*y+t3.*t4.*tpp4.*y+t2.*t5.*tpp5.*y+offC1.*t3.*t4.*tp4.*tp5.*2.0-offC2.*t4.*t5.*tp4.*tp5.*2.0+offP1.*t3.*t4.*tp4.*tp5.*2.0-offP2.*t4.*t5.*tp4.*tp5.*2.0+t3.*t4.*tp4.*tp5.*x.*2.0;
    // 'kin_xyzbc_tt_J2P_jt:50' et4 = t4.*t5.*tp4.*tp5.*y.*-2.0;
    // 'kin_xyzbc_tt_J2P_jt:51' et5 =
    // -t4.*tpp3+offB1.*t2.*t6+offB3.*t4.*t6+offC3.*t4.*t6+offP3.*t4.*t6+offB1.*t4.*tpp4-offB3.*t2.*tpp4-offC3.*t2.*tpp4-offP3.*t2.*tpp4-t2.*t3.*tpp1+t2.*t5.*tpp2-t2.*tp3.*tp4.*2.0+t4.*t6.*z-t2.*tpp4.*z+offC1.*t2.*t3.*t6+offC1.*t2.*t3.*t7-offC2.*t2.*t5.*t6-offC2.*t2.*t5.*t7+offP1.*t2.*t3.*t6+offP1.*t2.*t3.*t7-offP2.*t2.*t5.*t6-offP2.*t2.*t5.*t7+offC1.*t3.*t4.*tpp4+offC2.*t2.*t3.*tpp5+offC1.*t2.*t5.*tpp5-offC2.*t4.*t5.*tpp4+offP1.*t3.*t4.*tpp4+offP2.*t2.*t3.*tpp5+offP1.*t2.*t5.*tpp5-offP2.*t4.*t5.*tpp4+t2.*t3.*tp2.*tp5.*2.0+t3.*t4.*tp1.*tp4.*2.0+t2.*t5.*tp1.*tp5.*2.0-t4.*t5.*tp2.*tp4.*2.0+t2.*t3.*t6.*x+t2.*t3.*t7.*x;
    // 'kin_xyzbc_tt_J2P_jt:52' et6 =
    // t3.*t4.*tpp4.*x+t2.*t5.*tpp5.*x-t2.*t5.*t6.*y-t2.*t5.*t7.*y+t2.*t3.*tpp5.*y-t4.*t5.*tpp4.*y-offC2.*t3.*t4.*tp4.*tp5.*2.0-offC1.*t4.*t5.*tp4.*tp5.*2.0-offP2.*t3.*t4.*tp4.*tp5.*2.0-offP1.*t4.*t5.*tp4.*tp5.*2.0-t4.*t5.*tp4.*tp5.*x.*2.0-t3.*t4.*tp4.*tp5.*y.*2.0;
    // 'kin_xyzbc_tt_J2P_jt:53' et7 =
    // t3.*t4.*tpp2+t4.*t5.*tpp1-offC2.*t3.*t4.*t6-offC1.*t4.*t5.*t6-offC2.*t3.*t4.*t7-offC1.*t4.*t5.*t7-offP2.*t3.*t4.*t6-offP1.*t4.*t5.*t6-offP2.*t3.*t4.*t7-offP1.*t4.*t5.*t7+offC2.*t2.*t3.*tpp4+offC1.*t2.*t5.*tpp4+offC1.*t3.*t4.*tpp5-offC2.*t4.*t5.*tpp5+offP2.*t2.*t3.*tpp4+offP1.*t2.*t5.*tpp4+offP1.*t3.*t4.*tpp5-offP2.*t4.*t5.*tpp5+t2.*t3.*tp2.*tp4.*2.0+t2.*t5.*tp1.*tp4.*2.0+t3.*t4.*tp1.*tp5.*2.0-t4.*t5.*tp2.*tp5.*2.0-t4.*t5.*t6.*x-t4.*t5.*t7.*x+t2.*t5.*tpp4.*x+t3.*t4.*tpp5.*x-t3.*t4.*t6.*y-t3.*t4.*t7.*y+t2.*t3.*tpp4.*y-t4.*t5.*tpp5.*y+offC1.*t2.*t3.*tp4.*tp5.*2.0-offC2.*t2.*t5.*tp4.*tp5.*2.0;
    // 'kin_xyzbc_tt_J2P_jt:54' et8 =
    // offP1.*t2.*t3.*tp4.*tp5.*2.0-offP2.*t2.*t5.*tp4.*tp5.*2.0+t2.*t3.*tp4.*tp5.*x.*2.0-t2.*t5.*tp4.*tp5.*y.*2.0;
    // 'kin_xyzbc_tt_J2P_jt:55' mt1 =
    // [-t2.*t3.*t6-t2.*t3.*t7-t3.*t4.*tpp4-t2.*t5.*tpp5+t4.*t5.*tp4.*tp5.*2.0,-t5.*t7+t3.*tpp5,t3.*t4.*t6+t3.*t4.*t7-t2.*t3.*tpp4+t4.*t5.*tpp5+t2.*t5.*tp4.*tp5.*2.0,0.0,0.0,t2.*t5.*t6+t2.*t5.*t7-t2.*t3.*tpp5+t4.*t5.*tpp4+t3.*t4.*tp4.*tp5.*2.0,-t3.*t7-t5.*tpp5,-t4.*t5.*t6-t4.*t5.*t7+t2.*t5.*tpp4+t3.*t4.*tpp5+t2.*t3.*tp4.*tp5.*2.0,0.0,0.0,-t4.*t6+t2.*tpp4,0.0,-t2.*t6-t4.*tpp4,0.0,0.0,et1+et2,0.0,et5+et6,0.0,0.0,et3+et4];
    // 'kin_xyzbc_tt_J2P_jt:56' mt2 =
    // [t3.*tpp1-t5.*tpp2-offC1.*t3.*t7+offC2.*t5.*t7-offP1.*t3.*t7+offP2.*t5.*t7-offC2.*t3.*tpp5-offC1.*t5.*tpp5-offP2.*t3.*tpp5-offP1.*t5.*tpp5-t3.*tp2.*tp5.*2.0-t5.*tp1.*tp5.*2.0-t3.*t7.*x-t5.*tpp5.*x+t5.*t7.*y-t3.*tpp5.*y,et7+et8,0.0,0.0];
    // 'kin_xyzbc_tt_J2P_jt:57' J2P_jt = reshape([mt1,mt2],5,5);
    t2_tmp = t3 * t4;
    b_t2_tmp = t2 * t3;
    c_t2_tmp = t4 * t5;
    d_t2_tmp = t2 * t5;
    e_t2_tmp = b_t2_tmp * t7;
    f_t2_tmp = t2_tmp * in3[3];
    g_t2_tmp = d_t2_tmp * in3[4];
    h_t2_tmp = c_t2_tmp * in2[3] * in2[4];
    i_t2_tmp = -t2 * t3;
    b_t2[0] = (((i_t2_tmp * t6 - e_t2_tmp) - f_t2_tmp) - g_t2_tmp) + h_t2_tmp * 2.0;
    j_t2_tmp = t3 * in3[4];
    b_t2[1] = -t5 * t7 + j_t2_tmp;
    k_t2_tmp = t2_tmp * t6;
    l_t2_tmp = t2_tmp * t7;
    m_t2_tmp = b_t2_tmp * in3[3];
    n_t2_tmp = c_t2_tmp * in3[4];
    o_t2_tmp = d_t2_tmp * in2[3] * in2[4];
    b_t2[2] = (((k_t2_tmp + l_t2_tmp) - m_t2_tmp) + n_t2_tmp) + o_t2_tmp * 2.0;
    b_t2[3] = 0.0;
    b_t2[4] = 0.0;
    p_t2_tmp = d_t2_tmp * t6;
    q_t2_tmp = d_t2_tmp * t7;
    r_t2_tmp = b_t2_tmp * in3[4];
    s_t2_tmp = c_t2_tmp * in3[3];
    t_t2_tmp = t2_tmp * in2[3] * in2[4];
    b_t2[5] = (((p_t2_tmp + q_t2_tmp) - r_t2_tmp) + s_t2_tmp) + t_t2_tmp * 2.0;
    u_t2_tmp = t5 * in3[4];
    b_t2[6] = -t3 * t7 - u_t2_tmp;
    v_t2_tmp = c_t2_tmp * t7;
    w_t2_tmp = d_t2_tmp * in3[3];
    x_t2_tmp = t2_tmp * in3[4];
    y_t2_tmp = b_t2_tmp * in2[3] * in2[4];
    b_t2[7] = (((-t4 * t5 * t6 - v_t2_tmp) + w_t2_tmp) + x_t2_tmp) + y_t2_tmp * 2.0;
    b_t2[8] = 0.0;
    b_t2[9] = 0.0;
    ab_t2_tmp = t2 * in3[3];
    b_t2[10] = -t4 * t6 + ab_t2_tmp;
    b_t2[11] = 0.0;
    bb_t2_tmp = t4 * in3[3];
    b_t2[12] = -t2 * t6 - bb_t2_tmp;
    b_t2[13] = 0.0;
    b_t2[14] = 0.0;
    t2_tmp_tmp = in4[12] * t3;
    cb_t2_tmp = t2_tmp_tmp * t4;
    db_t2_tmp = in4[13] * t4 * t5;
    b_t2_tmp_tmp = in4[6] * t3;
    eb_t2_tmp = b_t2_tmp_tmp * t4;
    fb_t2_tmp = in4[7] * t4 * t5;
    gb_t2_tmp = in4[13] * t2;
    hb_t2_tmp = in4[12] * t2;
    ib_t2_tmp = in4[7] * t2;
    jb_t2_tmp = in4[6] * t2;
    kb_t2_tmp = in4[9] * t2;
    lb_t2_tmp = in4[11] * t4;
    mb_t2_tmp = in4[14] * t4;
    nb_t2_tmp = in4[8] * t4;
    ob_t2_tmp = in4[9] * t4;
    pb_t2_tmp = in4[11] * t2;
    qb_t2_tmp = in4[14] * t2;
    rb_t2_tmp = in4[8] * t2;
    sb_t2_tmp = hb_t2_tmp * t3;
    tb_t2_tmp = gb_t2_tmp * t5;
    ub_t2_tmp = jb_t2_tmp * t3;
    vb_t2_tmp = ib_t2_tmp * t5;
    wb_t2_tmp = gb_t2_tmp * t3;
    xb_t2_tmp = hb_t2_tmp * t5;
    yb_t2_tmp = ib_t2_tmp * t3;
    ac_t2_tmp = jb_t2_tmp * t5;
    c_t2_tmp_tmp = in4[13] * t3;
    bc_t2_tmp = c_t2_tmp_tmp * t4;
    cc_t2_tmp = in4[12] * t4 * t5;
    d_t2_tmp_tmp = in4[7] * t3;
    dc_t2_tmp = d_t2_tmp_tmp * t4;
    ec_t2_tmp = in4[6] * t4 * t5;
    fc_t2_tmp = b_t2_tmp * in2[0];
    gc_t2_tmp = t2_tmp * in2[1];
    hc_t2_tmp = d_t2_tmp * in2[1];
    ic_t2_tmp = c_t2_tmp * in2[0];
    jc_t2_tmp = c_t2_tmp * t6;
    b_t2[15] = ((((((((((((((((((((((((((((((((((t2 * in3[2] + ob_t2_tmp * t6) - pb_t2_tmp * t6) -
                                               qb_t2_tmp * t6) -
                                              rb_t2_tmp * t6) -
                                             kb_t2_tmp * in3[3]) -
                                            lb_t2_tmp * in3[3]) -
                                           mb_t2_tmp * in3[3]) -
                                          nb_t2_tmp * in3[3]) -
                                         t2_tmp * in3[0]) +
                                        c_t2_tmp * in3[1]) -
                                       t4 * in2[2] * in2[3] * 2.0) -
                                      t2 * t6 * in1[2]) -
                                     bb_t2_tmp * in1[2]) +
                                    cb_t2_tmp * t6) +
                                   cb_t2_tmp * t7) -
                                  db_t2_tmp * t6) -
                                 db_t2_tmp * t7) +
                                eb_t2_tmp * t6) +
                               eb_t2_tmp * t7) -
                              fb_t2_tmp * t6) -
                             fb_t2_tmp * t7) -
                            sb_t2_tmp * in3[3]) +
                           tb_t2_tmp * in3[3]) +
                          bc_t2_tmp * in3[4]) +
                         cc_t2_tmp * in3[4]) -
                        ub_t2_tmp * in3[3]) +
                       vb_t2_tmp * in3[3]) +
                      dc_t2_tmp * in3[4]) +
                     ec_t2_tmp * in3[4]) -
                    fc_t2_tmp * in2[3] * 2.0) +
                   hc_t2_tmp * in2[3] * 2.0) +
                  gc_t2_tmp * in2[4] * 2.0) +
                 ic_t2_tmp * in2[4] * 2.0) +
                k_t2_tmp * in1[0]) +
               ((((((((((((l_t2_tmp * in1[0] - m_t2_tmp * in1[0]) + n_t2_tmp * in1[0]) -
                         jc_t2_tmp * in1[1]) -
                        v_t2_tmp * in1[1]) +
                       w_t2_tmp * in1[1]) +
                      x_t2_tmp * in1[1]) +
                     wb_t2_tmp * in2[3] * in2[4] * 2.0) +
                    xb_t2_tmp * in2[3] * in2[4] * 2.0) +
                   yb_t2_tmp * in2[3] * in2[4] * 2.0) +
                  ac_t2_tmp * in2[3] * in2[4] * 2.0) +
                 o_t2_tmp * in1[0] * 2.0) +
                y_t2_tmp * in1[1] * 2.0);
    b_t2[16] = 0.0;
    kc_t2_tmp = b_t2_tmp * t6;
    lc_t2_tmp = b_t2_tmp * in2[1];
    mc_t2_tmp = d_t2_tmp * in2[0];
    nc_t2_tmp = t2_tmp * in2[0];
    oc_t2_tmp = c_t2_tmp * in2[1];
    b_t2[17] = (((((((((((((((((((((((((((((((((((-t4 * in3[2] + kb_t2_tmp * t6) + lb_t2_tmp * t6) +
                                                mb_t2_tmp * t6) +
                                               nb_t2_tmp * t6) +
                                              ob_t2_tmp * in3[3]) -
                                             pb_t2_tmp * in3[3]) -
                                            qb_t2_tmp * in3[3]) -
                                           rb_t2_tmp * in3[3]) -
                                          b_t2_tmp * in3[0]) +
                                         d_t2_tmp * in3[1]) -
                                        t2 * in2[2] * in2[3] * 2.0) +
                                       t4 * t6 * in1[2]) -
                                      ab_t2_tmp * in1[2]) +
                                     sb_t2_tmp * t6) +
                                    sb_t2_tmp * t7) -
                                   tb_t2_tmp * t6) -
                                  tb_t2_tmp * t7) +
                                 ub_t2_tmp * t6) +
                                ub_t2_tmp * t7) -
                               vb_t2_tmp * t6) -
                              vb_t2_tmp * t7) +
                             cb_t2_tmp * in3[3]) +
                            wb_t2_tmp * in3[4]) +
                           xb_t2_tmp * in3[4]) -
                          db_t2_tmp * in3[3]) +
                         eb_t2_tmp * in3[3]) +
                        yb_t2_tmp * in3[4]) +
                       ac_t2_tmp * in3[4]) -
                      fb_t2_tmp * in3[3]) +
                     lc_t2_tmp * in2[4] * 2.0) +
                    nc_t2_tmp * in2[3] * 2.0) +
                   mc_t2_tmp * in2[4] * 2.0) -
                  oc_t2_tmp * in2[3] * 2.0) +
                 kc_t2_tmp * in1[0]) +
                e_t2_tmp * in1[0]) +
               (((((((((((f_t2_tmp * in1[0] + g_t2_tmp * in1[0]) - p_t2_tmp * in1[1]) -
                        q_t2_tmp * in1[1]) +
                       r_t2_tmp * in1[1]) -
                      s_t2_tmp * in1[1]) -
                     bc_t2_tmp * in2[3] * in2[4] * 2.0) -
                    cc_t2_tmp * in2[3] * in2[4] * 2.0) -
                   dc_t2_tmp * in2[3] * in2[4] * 2.0) -
                  ec_t2_tmp * in2[3] * in2[4] * 2.0) -
                 h_t2_tmp * in1[0] * 2.0) -
                t_t2_tmp * in1[1] * 2.0);
    b_t2[18] = 0.0;
    b_t2[19] = 0.0;
    b_t2[20] =
        ((((((((((((((((((((((((((((((((((i_t2_tmp * in3[1] - d_t2_tmp * in3[0]) + wb_t2_tmp * t6) +
                                        xb_t2_tmp * t6) +
                                       wb_t2_tmp * t7) +
                                      xb_t2_tmp * t7) +
                                     yb_t2_tmp * t6) +
                                    ac_t2_tmp * t6) +
                                   yb_t2_tmp * t7) +
                                  ac_t2_tmp * t7) -
                                 sb_t2_tmp * in3[4]) +
                                bc_t2_tmp * in3[3]) +
                               cc_t2_tmp * in3[3]) +
                              tb_t2_tmp * in3[4]) -
                             ub_t2_tmp * in3[4]) +
                            dc_t2_tmp * in3[3]) +
                           ec_t2_tmp * in3[3]) +
                          vb_t2_tmp * in3[4]) -
                         fc_t2_tmp * in2[4] * 2.0) +
                        gc_t2_tmp * in2[3] * 2.0) +
                       hc_t2_tmp * in2[4] * 2.0) +
                      ic_t2_tmp * in2[3] * 2.0) +
                     p_t2_tmp * in1[0]) +
                    q_t2_tmp * in1[0]) -
                   r_t2_tmp * in1[0]) +
                  s_t2_tmp * in1[0]) +
                 kc_t2_tmp * in1[1]) +
                e_t2_tmp * in1[1]) +
               f_t2_tmp * in1[1]) +
              g_t2_tmp * in1[1]) +
             cb_t2_tmp * in2[3] * in2[4] * 2.0) -
            db_t2_tmp * in2[3] * in2[4] * 2.0) +
           eb_t2_tmp * in2[3] * in2[4] * 2.0) -
          fb_t2_tmp * in2[3] * in2[4] * 2.0) +
         t_t2_tmp * in1[0] * 2.0) +
        h_t2_tmp * in1[1] * -2.0;
    b_t2[21] = ((((((((((((((t3 * in3[0] - t5 * in3[1]) - t2_tmp_tmp * t7) + in4[13] * t5 * t7) -
                          b_t2_tmp_tmp * t7) +
                         in4[7] * t5 * t7) -
                        c_t2_tmp_tmp * in3[4]) -
                       in4[12] * t5 * in3[4]) -
                      d_t2_tmp_tmp * in3[4]) -
                     in4[6] * t5 * in3[4]) -
                    t3 * in2[1] * in2[4] * 2.0) -
                   t5 * in2[0] * in2[4] * 2.0) -
                  t3 * t7 * in1[0]) -
                 u_t2_tmp * in1[0]) +
                t5 * t7 * in1[1]) -
               j_t2_tmp * in1[1];
    b_t2[22] =
        (((((((((((((((((((((((((((((((t2_tmp * in3[1] + c_t2_tmp * in3[0]) - bc_t2_tmp * t6) -
                                     cc_t2_tmp * t6) -
                                    bc_t2_tmp * t7) -
                                   cc_t2_tmp * t7) -
                                  dc_t2_tmp * t6) -
                                 ec_t2_tmp * t6) -
                                dc_t2_tmp * t7) -
                               ec_t2_tmp * t7) +
                              wb_t2_tmp * in3[3]) +
                             xb_t2_tmp * in3[3]) +
                            cb_t2_tmp * in3[4]) -
                           db_t2_tmp * in3[4]) +
                          yb_t2_tmp * in3[3]) +
                         ac_t2_tmp * in3[3]) +
                        eb_t2_tmp * in3[4]) -
                       fb_t2_tmp * in3[4]) +
                      lc_t2_tmp * in2[3] * 2.0) +
                     mc_t2_tmp * in2[3] * 2.0) +
                    nc_t2_tmp * in2[4] * 2.0) -
                   oc_t2_tmp * in2[4] * 2.0) -
                  jc_t2_tmp * in1[0]) -
                 v_t2_tmp * in1[0]) +
                w_t2_tmp * in1[0]) +
               x_t2_tmp * in1[0]) -
              k_t2_tmp * in1[1]) -
             l_t2_tmp * in1[1]) +
            m_t2_tmp * in1[1]) -
           n_t2_tmp * in1[1]) +
          sb_t2_tmp * in2[3] * in2[4] * 2.0) -
         tb_t2_tmp * in2[3] * in2[4] * 2.0) +
        (((ub_t2_tmp * in2[3] * in2[4] * 2.0 - vb_t2_tmp * in2[3] * in2[4] * 2.0) +
          y_t2_tmp * in1[0] * 2.0) -
         o_t2_tmp * in1[1] * 2.0);
    b_t2[23] = 0.0;
    b_t2[24] = 0.0;
    for (int i{0}; i < 5; i++) {
        for (int i1{0}; i1 < 5; i1++) {
            J2P_jt[i][i1] = b_t2[i1 + 5 * i];
        }
    }
}

} // namespace ocn

//
// File trailer for kin_xyzbc_tt_J2P_jt.cpp
//
// [EOF]
//
